import { renderless as renderless$1, api as api$1 } from '@opentinyvue/vue-renderless/cascader-select/vue';
import { defineComponent, $prefix, $props, setup, props } from '@opentinyvue/vue-common';
import { renderless, api } from '@opentinyvue/vue-renderless/cascader-select/column';
import ActionSheet from '@opentinyvue/vue-action-sheet';
import Button from '@opentinyvue/vue-button';

function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  var hook;
  if (injectStyles) {
    hook = injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function(n) {
    for (var e = 1; e < arguments.length; e++) {
      var t = arguments[e];
      for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
var classes = {
  "header-item": "cursor-pointer px-4 flex items-center justify-center min-w-[50px] h-full text-sm",
  "picker-column": "flex relative before:content-[''] before:absolute before:top-1/2 before:h-[var(--lineHeight)] before:w-full before:border-t before:border-b before:border-color-bg-3 before:scale-90 before:-translate-y-1/2",
  "picker-columnitem": "flex-1 h-full relative",
  "picker-bar": "flex h-12 items-center justify-between",
  "col-list": "relative block w-full h-full overflow-hidden text-center scrolling-touch",
  "col-roller": "absolute block top-1/2 w-full z1 -translate-y-1/2 [transform-style:preserve-3d] h-[var(--lineHeight)]",
  "col-roller-item": "block [backface-visibility:hidden] absolute top-0 w-full h-9 leading-9 text-color-text-primary truncate",
  "col-item-tile": "block text-center w-full truncate",
  "col-roller-mask": "absolute w-full h-full block [background-image:linear-gradient(180deg,rgba(255,255,255,0.9),rgba(255,255,255,0.4)),linear-gradient(0deg,rgba(255,255,255,0.9),rgba(255,255,255,0.4))] [background-position:top,bottom] bg-no-repeat z-1"
};
var __vue2_script$1 = defineComponent({
  name: $prefix + "CascaderSelectColumn",
  props: _extends({}, $props, {
    // 当前选中项
    value: [String, Number],
    defaultValue: [String, Number],
    columnsType: String,
    column: {
      type: Array,
      default: function _default() {
        return [];
      }
    },
    // 是否开启3D效果
    threeDimensional: {
      type: Boolean,
      default: true
    },
    swipeDuration: {
      type: [Number, String],
      default: 1e3
    },
    visibleOptionNum: {
      type: [Number, String],
      default: 7
    },
    optionHeight: {
      type: [Number, String],
      default: 36
    },
    fieldNames: {
      type: Object,
      default: function _default2() {
        return {};
      }
    },
    disabled: Boolean,
    visible: Boolean,
    textColor: {
      type: Object,
      default: function _default3() {
        return {};
      }
    }
  }),
  emits: ["click", "change"],
  setup: function setup$1(props2, context) {
    return setup({
      props: props2,
      context,
      renderless,
      api,
      classes,
      mono: true
    });
  }
});
var render$1 = function render$12() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    class: _vm.gcls("col-list"),
    attrs: {
      "data-tag": "tiny-cascader-picker__list"
    },
    on: {
      "touchstart": _vm.onTouchStart,
      "touchmove": _vm.onTouchMove,
      "touchend": _vm.onTouchEnd
    }
  }, [_c("div", {
    ref: "roller",
    class: _vm.gcls("col-roller"),
    style: _vm.threeDimensional ? _vm.state.touchRollerStyle : _vm.state.touchTileStyle,
    attrs: {
      "data-tag": "tiny-cascader-picker-roller"
    },
    on: {
      "transitionend": _vm.stopMomentum
    }
  }, _vm._l(_vm.column, function(item, index) {
    var _vm$m, _vm$m2, _vm$m3, _vm$m4;
    return _c("div", {
      key: item[_vm.fieldNames.value] || index
    }, [item && item[_vm.fieldNames.text] && _vm.threeDimensional ? _c("div", {
      class: _vm.m(_vm.gcls("col-roller-item"), {
        "invisible opacity-0": _vm.isHidden(index + 1)
      }, {
        "text-color-brand": item === _vm.column[_vm.state.currIndex - 1]
      }, {
        "text-color-icon-disabled": item === _vm.column[_vm.state.currIndex - 1] && _vm.disabled
      }),
      style: _vm.setRollerStyle(index + 1),
      attrs: {
        "data-tag": "tiny-cascader-picker-roller-item"
      }
    }, [_vm._v(" " + _vm._s(item[_vm.fieldNames.text]) + " ")]) : _vm._e(), item && item[_vm.fieldNames.text] && !_vm.threeDimensional ? _c("div", {
      class: _vm.m(_vm.gcls("col-item-tile"), _vm.textColor.default || "text-color-text-primary", (_vm$m = {}, _vm$m[_vm.textColor.third || "text-color-icon-placeholder"] = _vm.OptionStyle(item, _vm.column, 2), _vm$m), (_vm$m2 = {}, _vm$m2[_vm.textColor.second || "text-color-icon-secondary"] = _vm.OptionStyle(item, _vm.column, 1), _vm$m2), (_vm$m3 = {}, _vm$m3[_vm.textColor.first || "text-color-icon-focus"] = _vm.OptionStyle(item, _vm.column, 0), _vm$m3), (_vm$m4 = {}, _vm$m4[_vm.textColor.disabled || "text-color-icon-disabled"] = _vm.OptionStyle(item, _vm.column, 0) && _vm.disabled, _vm$m4)),
      style: {
        height: _vm.pxCheck(_vm.optionHeight),
        lineHeight: _vm.pxCheck(_vm.optionHeight)
      },
      attrs: {
        "data-tag": "tiny-cascader-picker-roller-item-tile"
      }
    }, [_vm._v(" " + _vm._s(item[_vm.fieldNames.text]) + " ")]) : _vm._e()]);
  }), 0), _c("div", {
    class: _vm.gcls("col-roller-mask"),
    style: _vm.state.maskStyles,
    attrs: {
      "data-tag": "tiny-cascader-picker-roller-mask"
    }
  })]);
};
var staticRenderFns$1 = [];
var __cssModules$1 = {};
var __component__$1 = /* @__PURE__ */ normalizeComponent(__vue2_script$1, render$1, staticRenderFns$1, false, __vue2_injectStyles$1);
function __vue2_injectStyles$1(context) {
  for (var o in __cssModules$1) {
    this[o] = __cssModules$1[o];
  }
}
var PickerColumn = /* @__PURE__ */ function() {
  return __component__$1.exports;
}();
var __vue2_script = defineComponent({
  components: {
    PickerColumn,
    TinyActionSheet: ActionSheet,
    TinyButton: Button
  },
  emits: ["cancel", "change", "confirm", "update:modelValue", "update:visible"],
  props: [].concat(props, ["modelValue", "options", "threeDimensional", "swipeDuration", "visibleOptionNum", "optionHeight", "fieldNames", "visible", "valueType", "valueField", "textField", "childrenField", "disabled", "textColor", "lockScroll", "customClass", "panelCustomClass", "type", "defaultValue"]),
  setup: function setup2(props2, context) {
    return setup({
      props: props2,
      context,
      renderless: renderless$1,
      api: api$1,
      classes
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    attrs: {
      "data-tag": "tiny-mobile-cascader-select"
    }
  }, [_c("tiny-action-sheet", {
    attrs: {
      "custom-class": _vm.m("rounded-t-lg bg-color-bg-1", _vm.customClass),
      "lock-scroll": _vm.lockScroll,
      "visible": _vm.state.actionSheetVisible
    },
    on: {
      "update:visible": function updateVisible($event) {
        _vm.state.actionSheetVisible = $event;
      }
    },
    scopedSlots: _vm._u([{
      key: "header-left",
      fn: function fn() {
        return [_vm._t("header-left")];
      },
      proxy: true
    }], null, true)
  }, [_c("div", {
    staticClass: "w-full h-max rounded-t-lg bg-color-bg-1 select-none overflow-hidden",
    attrs: {
      "data-tag": "tiny-mobile-cascader-select-body"
    },
    on: {
      "click": function click($event) {
        $event.stopPropagation();
      }
    }
  }, [_c("div", {
    ref: "selectPanel",
    class: _vm.m("w-full h-max grid", _vm.panelCustomClass),
    attrs: {
      "data-tag": "tiny-mobile-cascader-select-selectpanel"
    }
  }, [_c("div", {
    staticClass: "relative text-sm",
    attrs: {
      "data-tag": "tiny-cascader-select-picker"
    }
  }, [_vm._t("top"), _c("div", {
    class: _vm.gcls("picker-column"),
    style: _vm.columnStyle,
    attrs: {
      "data-tag": "tiny-cascader-picker__column"
    }
  }, _vm._l(_vm.columnsList, function(column, columnIndex) {
    return _c("div", {
      key: columnIndex,
      class: _vm.gcls("picker-columnitem"),
      attrs: {
        "data-tag": "tiny-cascader-picker__columnitem"
      }
    }, [columnIndex > 0 ? _vm._t("split") : _vm._e(), _c("picker-column", {
      ref: "swipeRef",
      refInFor: true,
      attrs: {
        "column": column,
        "disabled": _vm.isDisabled,
        "text-color": _vm.textColor,
        "columns-type": _vm.columnsType,
        "field-names": _vm.columnFieldNames,
        "value": _vm.defaultValues[columnIndex],
        "default-value": _vm.defaultValue[columnIndex],
        "three-dimensional": _vm.threeDimensional,
        "swipe-duration": _vm.swipeDuration,
        "visible-option-num": _vm.visibleOptionNum,
        "option-height": _vm.optionHeight,
        "visible": _vm.state.actionSheetVisible
      },
      on: {
        "change": function change(option) {
          _vm.changeHandler(columnIndex, option);
        }
      }
    })], 2);
  }), 0), _vm._t("default")], 2)]), _c("div", {
    staticClass: "w-full h-11 mt-4 flex justify-center items-center",
    attrs: {
      "data-tag": "tiny-mobile-cascader-select-button"
    }
  }, [_c("tiny-button", {
    attrs: {
      "type": "primary",
      "size": "large",
      "custom-class": _vm.m("h-10 sm:h-10 w-full sm:w-auto mx-4 sm:mx-0 flex justify-center items-center", _vm.isDisabled ? "bg-color-icon-disabled" : "bg-color-icon-focus"),
      "disabled": _vm.isDisabled
    },
    on: {
      "click": _vm.confirm
    }
  }, [_vm._v(_vm._s(_vm.t("ui.button.confirm")))])], 1)])])], 1);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var mobileFirst = /* @__PURE__ */ function() {
  return __component__.exports;
}();

export { mobileFirst as default };
